{{
  Simple clock application demonstrating StrFmt / BufStrFmt
  and related modular programming techniques.  Uses demo board
  or protoboard VGA and keyboard.
}}

CON

  _clkmode  = xtal1 + pll16x
  _xinfreq  = 5_000_000                                            

VAR

  byte  title[33]

OBJ

  key       : "keyboard"
  vid       : "vga_text_nf"
  rtc       : "clkengine"
  rtcset    : "settime"
  rtcstyle  : "setstyle"
  sf        : "strfmt"
  bsf       : "bufstrfmt"
  tfmt      : "tdfmt"
  ui        : "ui_methods"

PUB Main | c, s, s0, ptr

  key.start(26, 27)
  vid.start(16)
  rtc.start

  waitcnt(cnt + clkfreq/10) 'give cogs time to start
  bsf.setbuf(key.pasmbase, key.pasmend) 'recycle keyboard pasm image

  bytemove(@title, string("Clock Demo"),11) 

  bkg
  repeat
    repeat while (c := key.key) <> 0
      case c
        "a".."z":
          'touppercase
          c -= 32  
      case c
        "A":
          vid.str(string(7, $B, 2, "  Enter Title:", $C, 2))
          ui.doinput(@title, 2, 4, 28)
          vid.out($c)
          vid.out(0)
        "B":
          rtcset.set
        "C":
          rtcstyle.set
      bkg
      s0 := $FF 'force screen redraw
    rtc.service
    s := tfmt.second(rtc.readtime)
    if s <> s0
      'redraw when second changes
      vid.str(string(1, 13, 13))
      'assign a big enough buffer and build T/D string in place
      ptr := tfmt.timefmt(rtc.readtime)
      ptr := bsf.chcat(ptr, " ")
      ptr := bsf.strcat(ptr, tfmt.datefmt(rtc.readdate))
      'and center the whole thing on screen
      vid.str(bsf.cstr(ptr, vid#cols))
      s0 := s

PRI bkg
  vid.str(string(7, 13, 13))
  vid.str(bsf.cstr(@title, vid#cols))
  vid.str(string(13, 13, $a, 9, "A = Set Title",13, $a, 9, "B = Set Time", 13, $a, 9, "C = Set Format"))  